<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>XsArray Class Reference</title>
<link href="xsens.css" rel="stylesheet" type="text/css"/>
</head><body>
<img class="logo" src="xsenslogo.jpg" alt="Xsens Logo" />
	<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="#related">Related Functions</a> &#124;
<a href="class_xs_array-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">XsArray Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Provides generic storage for data in an array and manipulation operations on that data.  
 <a href="struct_xs_array.html#details">More...</a></p>
<div class="dynheader">
Inheritance diagram for XsArray:</div>
<div class="dyncontent">
<div class="center"><img src="struct_xs_array__inherit__graph.png" border="0" usemap="#_xs_array_inherit__map" alt="Inheritance graph"/></div>
<map name="_xs_array_inherit__map" id="_xs_array_inherit__map">
<area shape="rect" id="node2" href="struct_xs_array_impl.html" title="A C++ wrapper for XsArray, this is a template class for the actual specialized classes. " alt="" coords="177,12,327,39"/>
<area shape="rect" id="node4" href="struct_xs_array_impl.html" title="XsArrayImpl\&lt; int, g\l_xsIntArrayDescriptor,\l XsIntArray \&gt;" alt="" coords="177,63,327,119"/>
<area shape="rect" id="node6" href="struct_xs_array_impl.html" title="XsArrayImpl\&lt; int64\l_t, g_xsInt64ArrayDescriptor,\l XsInt64Array \&gt;" alt="" coords="157,143,347,199"/>
<area shape="rect" id="node8" href="struct_xs_array_impl.html" title="XsArrayImpl\&lt; uint8\l_t, g_xsByteArrayDescriptor,\l XsByteArray \&gt;" alt="" coords="157,223,347,279"/>
<area shape="rect" id="node10" href="struct_xs_array_impl.html" title="XsArrayImpl\&lt; XsDeviceId,\l g_xsDeviceIdArrayDescriptor,\l XsDeviceIdArray \&gt;" alt="" coords="154,303,350,359"/>
<area shape="rect" id="node12" href="struct_xs_array_impl.html" title="XsArrayImpl\&lt; XsMessage,\l g_xsMessageArrayDescriptor,\l XsMessageArray \&gt;" alt="" coords="151,383,353,439"/>
<area shape="rect" id="node14" href="struct_xs_array_impl.html" title="XsArrayImpl\&lt; XsOutputConfiguration,\l g_xsOutputConfigurationArrayDescriptor,\l XsOutputConfigurationArray \&gt;" alt="" coords="121,463,383,519"/>
<area shape="rect" id="node16" href="struct_xs_array_impl.html" title="XsArrayImpl\&lt; XsPortInfo,\l g_xsPortInfoArrayDescriptor,\l XsPortInfoArray \&gt;" alt="" coords="156,543,348,599"/>
<area shape="rect" id="node18" href="struct_xs_array_impl.html" title="XsArrayImpl\&lt; XsString,\l g_xsStringArrayDescriptor,\l XsStringArray \&gt;" alt="" coords="161,623,343,679"/>
<area shape="rect" id="node20" href="struct_xs_array_impl.html" title="XsArrayImpl\&lt; XsSyncSetting,\l g_xsSyncSettingArrayDescriptor,\l XsSyncSettingArray \&gt;" alt="" coords="143,703,361,759"/>
<area shape="rect" id="node3" href="struct_xs_string.html" title="A 0&#45;terminated managed string of characters. " alt="" coords="434,5,611,46"/>
<area shape="rect" id="node5" href="struct_xs_int_array.html" title="A list of XsInt values. " alt="" coords="482,77,563,104"/>
<area shape="rect" id="node7" href="struct_xs_int64_array.html" title="A list of int64_t values. " alt="" coords="475,157,570,184"/>
<area shape="rect" id="node9" href="struct_xs_byte_array.html" title="A list of uint8_t values. " alt="" coords="475,237,570,264"/>
<area shape="rect" id="node11" href="struct_xs_device_id_array.html" title="A list of XsDeviceId values. " alt="" coords="465,317,580,344"/>
<area shape="rect" id="node13" href="struct_xs_message_array.html" title="A list of XsMessage values. " alt="" coords="463,397,583,424"/>
<area shape="rect" id="node15" href="struct_xs_output_configuration_array.html" title="A list of XsOutputConfiguration values. " alt="" coords="432,477,613,504"/>
<area shape="rect" id="node17" href="struct_xs_port_info_array.html" title="A list of XsPortInfo values. " alt="" coords="467,557,578,584"/>
<area shape="rect" id="node19" href="struct_xs_string_array.html" title="A list of XsString values. " alt="" coords="472,637,573,664"/>
<area shape="rect" id="node21" href="struct_xs_sync_setting_array.html" title="A list of XsSyncSetting values. " alt="" coords="453,717,592,744"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aef16b8d4034c873176dec9742a83e6ac"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_array.html#aef16b8d4034c873176dec9742a83e6ac">XsArray</a> (<a class="el" href="struct_xs_array_descriptor.html">XsArrayDescriptor</a> const *descriptor, XsSize count=0, void const *src=0)</td></tr>
<tr class="memdesc:aef16b8d4034c873176dec9742a83e6ac"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initializes the <a class="el" href="struct_xs_array.html" title="Provides generic storage for data in an array and manipulation operations on that data...">XsArray</a> with space for <em>count</em> items and copies them from <em>src</em>.  <a href="#aef16b8d4034c873176dec9742a83e6ac">More...</a><br /></td></tr>
<tr class="separator:aef16b8d4034c873176dec9742a83e6ac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a40a6e7331ef221bc2abeceb9b72e8e6b"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_array.html#a40a6e7331ef221bc2abeceb9b72e8e6b">XsArray</a> (const <a class="el" href="struct_xs_array.html">XsArray</a> &amp;src)</td></tr>
<tr class="memdesc:a40a6e7331ef221bc2abeceb9b72e8e6b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initializes the <a class="el" href="struct_xs_array.html" title="Provides generic storage for data in an array and manipulation operations on that data...">XsArray</a> with a copy of <em>src</em>.  <a href="#a40a6e7331ef221bc2abeceb9b72e8e6b">More...</a><br /></td></tr>
<tr class="separator:a40a6e7331ef221bc2abeceb9b72e8e6b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af4ff96562e117bfcd424f9389f06c67e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af4ff96562e117bfcd424f9389f06c67e"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_array.html#af4ff96562e117bfcd424f9389f06c67e">XsArray</a> (<a class="el" href="struct_xs_array_descriptor.html">XsArrayDescriptor</a> const *descriptor, void *ref, XsSize count, <a class="el" href="group__enums.html#ga85bc9120949890bf9df4572ee9a95be5">XsDataFlags</a> flags)</td></tr>
<tr class="memdesc:af4ff96562e117bfcd424f9389f06c67e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates a array that references the data supplied in <em>ref</em> without allocating the data itself. <br /></td></tr>
<tr class="separator:af4ff96562e117bfcd424f9389f06c67e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aae0b944eec563d90e8ce5b3e765e1c70"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aae0b944eec563d90e8ce5b3e765e1c70"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_array.html#aae0b944eec563d90e8ce5b3e765e1c70">~XsArray</a> ()</td></tr>
<tr class="memdesc:aae0b944eec563d90e8ce5b3e765e1c70"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor. <br /></td></tr>
<tr class="separator:aae0b944eec563d90e8ce5b3e765e1c70"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0d5f403a6fd0facdd372528d3bc2ea78"><td class="memItemLeft" align="right" valign="top"><a class="el" href="struct_xs_array.html">XsArray</a> const &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_array.html#a0d5f403a6fd0facdd372528d3bc2ea78">operator=</a> (const <a class="el" href="struct_xs_array.html">XsArray</a> &amp;src)</td></tr>
<tr class="memdesc:a0d5f403a6fd0facdd372528d3bc2ea78"><td class="mdescLeft">&#160;</td><td class="mdescRight">Assignment operator.  <a href="#a0d5f403a6fd0facdd372528d3bc2ea78">More...</a><br /></td></tr>
<tr class="separator:a0d5f403a6fd0facdd372528d3bc2ea78"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:ae9b9cac2f5f744895311f343e07ee6c1"><td class="memItemLeft" align="right" valign="top">void *const&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_array.html#ae9b9cac2f5f744895311f343e07ee6c1">m_data</a></td></tr>
<tr class="separator:ae9b9cac2f5f744895311f343e07ee6c1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0793355de1a10a119d47ab5df4c51228"><td class="memItemLeft" align="right" valign="top">const XsSize&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_array.html#a0793355de1a10a119d47ab5df4c51228">m_size</a></td></tr>
<tr class="separator:a0793355de1a10a119d47ab5df4c51228"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9a81e31122b1cf37ced75d230407bd3a"><td class="memItemLeft" align="right" valign="top">const XsSize&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_array.html#a9a81e31122b1cf37ced75d230407bd3a">m_reserved</a></td></tr>
<tr class="separator:a9a81e31122b1cf37ced75d230407bd3a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9f4574fd74cedfc943e8e2bfa534e67f"><td class="memItemLeft" align="right" valign="top">const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_array.html#a9f4574fd74cedfc943e8e2bfa534e67f">m_flags</a></td></tr>
<tr class="separator:a9f4574fd74cedfc943e8e2bfa534e67f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abd1797e031ec46502cc2f43f2a07100d"><td class="memItemLeft" align="right" valign="top"><a class="el" href="struct_xs_array_descriptor.html">XsArrayDescriptor</a> const *const&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_xs_array.html#abd1797e031ec46502cc2f43f2a07100d">m_descriptor</a></td></tr>
<tr class="separator:abd1797e031ec46502cc2f43f2a07100d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="related"></a>
Related Functions</h2></td></tr>
<tr><td class="ititle" colspan="2"><p>(Note that these are not member functions.) </p>
</td></tr>
<tr class="memitem:ga7222e508e1e5b424ba34648a4e31fd98"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga7222e508e1e5b424ba34648a4e31fd98">XsArray_construct</a> (void *, <a class="el" href="struct_xs_array_descriptor.html">XsArrayDescriptor</a> const *const descriptor, XsSize count, void const *src)</td></tr>
<tr class="memdesc:ga7222e508e1e5b424ba34648a4e31fd98"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initializes the <a class="el" href="struct_xs_array.html" title="Provides generic storage for data in an array and manipulation operations on that data...">XsArray</a> with space for <em>count</em> items and copies them from <em>src</em>.  <a href="group__cinterface.html#ga7222e508e1e5b424ba34648a4e31fd98">More...</a><br /></td></tr>
<tr class="separator:ga7222e508e1e5b424ba34648a4e31fd98"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga953d7cc7a9ecd8405f2d85b50edc0d56"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga953d7cc7a9ecd8405f2d85b50edc0d56">XsArray_copyConstruct</a> (void *, void const *src)</td></tr>
<tr class="memdesc:ga953d7cc7a9ecd8405f2d85b50edc0d56"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initializes the <a class="el" href="struct_xs_array.html" title="Provides generic storage for data in an array and manipulation operations on that data...">XsArray</a> with a copy of <em>src</em>.  <a href="group__cinterface.html#ga953d7cc7a9ecd8405f2d85b50edc0d56">More...</a><br /></td></tr>
<tr class="separator:ga953d7cc7a9ecd8405f2d85b50edc0d56"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga754df4d700d8f759e3dd29aca3ab629f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga754df4d700d8f759e3dd29aca3ab629f">XsArray_destruct</a> (void *)</td></tr>
<tr class="memdesc:ga754df4d700d8f759e3dd29aca3ab629f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clears and frees memory allocated by the <a class="el" href="struct_xs_array.html" title="Provides generic storage for data in an array and manipulation operations on that data...">XsArray</a>.  <a href="group__cinterface.html#ga754df4d700d8f759e3dd29aca3ab629f">More...</a><br /></td></tr>
<tr class="separator:ga754df4d700d8f759e3dd29aca3ab629f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7b75e01c27f76b4d91aaa135e4e1a5c3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga7b75e01c27f76b4d91aaa135e4e1a5c3">XsArray_assign</a> (void *, XsSize count, void const *src)</td></tr>
<tr class="memdesc:ga7b75e01c27f76b4d91aaa135e4e1a5c3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reinitializes the <a class="el" href="struct_xs_array.html" title="Provides generic storage for data in an array and manipulation operations on that data...">XsArray</a> with space for <em>count</em> items and copies them from <em>src</em>.  <a href="group__cinterface.html#ga7b75e01c27f76b4d91aaa135e4e1a5c3">More...</a><br /></td></tr>
<tr class="separator:ga7b75e01c27f76b4d91aaa135e4e1a5c3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaee0c5bdd163bb6ca4e295e4ae2f4d1bb"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#gaee0c5bdd163bb6ca4e295e4ae2f4d1bb">XsArray_resize</a> (void *, XsSize count)</td></tr>
<tr class="memdesc:gaee0c5bdd163bb6ca4e295e4ae2f4d1bb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Resizes the existing list to <em>count</em> items.  <a href="group__cinterface.html#gaee0c5bdd163bb6ca4e295e4ae2f4d1bb">More...</a><br /></td></tr>
<tr class="separator:gaee0c5bdd163bb6ca4e295e4ae2f4d1bb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9e7d83d6428ea82a43d4c44167e75c54"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga9e7d83d6428ea82a43d4c44167e75c54">XsArray_reserve</a> (void *, XsSize count)</td></tr>
<tr class="memdesc:ga9e7d83d6428ea82a43d4c44167e75c54"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reserves space for <em>count</em> items.  <a href="group__cinterface.html#ga9e7d83d6428ea82a43d4c44167e75c54">More...</a><br /></td></tr>
<tr class="separator:ga9e7d83d6428ea82a43d4c44167e75c54"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga913d8e0e6cd77c2384b236e634e1881e"><td class="memItemLeft" align="right" valign="top">
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga913d8e0e6cd77c2384b236e634e1881e">XsArray_copy</a> (void *, void const *src)</td></tr>
<tr class="memdesc:ga913d8e0e6cd77c2384b236e634e1881e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Copy the contents of <em>src</em> to thisArray. <br /></td></tr>
<tr class="separator:ga913d8e0e6cd77c2384b236e634e1881e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga6556d22268f56b6dbd77befdbdad0f68"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga6556d22268f56b6dbd77befdbdad0f68">XsArray_append</a> (void *, void const *other)</td></tr>
<tr class="memdesc:ga6556d22268f56b6dbd77befdbdad0f68"><td class="mdescLeft">&#160;</td><td class="mdescRight">Appends the <em>other</em> list to thisArray list.  <a href="group__cinterface.html#ga6556d22268f56b6dbd77befdbdad0f68">More...</a><br /></td></tr>
<tr class="separator:ga6556d22268f56b6dbd77befdbdad0f68"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga1698369198b2417d5b5021a660281297"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga1698369198b2417d5b5021a660281297">XsArray_insert</a> (void *, XsSize index, XsSize count, void const *src)</td></tr>
<tr class="memdesc:ga1698369198b2417d5b5021a660281297"><td class="mdescLeft">&#160;</td><td class="mdescRight">Insert <em>count</em> items from <em>src</em> at <em>index</em> in the array.  <a href="group__cinterface.html#ga1698369198b2417d5b5021a660281297">More...</a><br /></td></tr>
<tr class="separator:ga1698369198b2417d5b5021a660281297"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad01697484c2c698f779345d64e199a5f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#gad01697484c2c698f779345d64e199a5f">XsArray_swap</a> (void *a, void *b)</td></tr>
<tr class="memdesc:gad01697484c2c698f779345d64e199a5f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Swap the contents of <em>a</em> with those of <em>b</em>.  <a href="group__cinterface.html#gad01697484c2c698f779345d64e199a5f">More...</a><br /></td></tr>
<tr class="separator:gad01697484c2c698f779345d64e199a5f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf24f468427e969e5a5daecb55cd36288"><td class="memItemLeft" align="right" valign="top">
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#gaf24f468427e969e5a5daecb55cd36288">XsArray_erase</a> (void *, XsSize index, XsSize count)</td></tr>
<tr class="memdesc:gaf24f468427e969e5a5daecb55cd36288"><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes a <em>count</em> items from the list starting at <em>index</em>. <br /></td></tr>
<tr class="separator:gaf24f468427e969e5a5daecb55cd36288"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga63b78f3e6c2315d7e9741a9336781c49"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga63b78f3e6c2315d7e9741a9336781c49">XsArray_compare</a> (void const *a, void const *b)</td></tr>
<tr class="memdesc:ga63b78f3e6c2315d7e9741a9336781c49"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns non-zero if the lists are different, 0 if they're equal.  <a href="group__cinterface.html#ga63b78f3e6c2315d7e9741a9336781c49">More...</a><br /></td></tr>
<tr class="separator:ga63b78f3e6c2315d7e9741a9336781c49"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga5791e1de38d98c182bded026fe32be5c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga5791e1de38d98c182bded026fe32be5c">XsArray_comparePredicate</a> (void const *a, void const *b, XsArrayItemCompareFunc predicate)</td></tr>
<tr class="memdesc:ga5791e1de38d98c182bded026fe32be5c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns non-zero if the lists are different, 0 if they're equal.  <a href="group__cinterface.html#ga5791e1de38d98c182bded026fe32be5c">More...</a><br /></td></tr>
<tr class="separator:ga5791e1de38d98c182bded026fe32be5c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga72561edb500d3e01c3aeb40de6d6a3db"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga72561edb500d3e01c3aeb40de6d6a3db">XsArray_compareSet</a> (void const *a, void const *b)</td></tr>
<tr class="memdesc:ga72561edb500d3e01c3aeb40de6d6a3db"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns -1 if <em>a</em> is smaller in some way than <em>b</em>, 1 if it is larger in some way and 0 if both lists are equal.  <a href="group__cinterface.html#ga72561edb500d3e01c3aeb40de6d6a3db">More...</a><br /></td></tr>
<tr class="separator:ga72561edb500d3e01c3aeb40de6d6a3db"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga6969403e331f28f7534cc2945ddcc09c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga6969403e331f28f7534cc2945ddcc09c">XsArray_find</a> (void const *, void const *needle)</td></tr>
<tr class="memdesc:ga6969403e331f28f7534cc2945ddcc09c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the index of <em>needle</em> in the list or -1 if it wasn't found.  <a href="group__cinterface.html#ga6969403e331f28f7534cc2945ddcc09c">More...</a><br /></td></tr>
<tr class="separator:ga6969403e331f28f7534cc2945ddcc09c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga111e1736fbf35d3e27bd175e69ee30db"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga111e1736fbf35d3e27bd175e69ee30db">XsArray_findPredicate</a> (void const *, void const *needle, XsArrayItemCompareFunc predicate)</td></tr>
<tr class="memdesc:ga111e1736fbf35d3e27bd175e69ee30db"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the index of <em>needle</em> in the list or -1 if it wasn't found.  <a href="group__cinterface.html#ga111e1736fbf35d3e27bd175e69ee30db">More...</a><br /></td></tr>
<tr class="separator:ga111e1736fbf35d3e27bd175e69ee30db"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4de36061187ffca3834ee403bfaff57d"><td class="memItemLeft" align="right" valign="top">void const *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga4de36061187ffca3834ee403bfaff57d">XsArray_at</a> (void const *, XsSize index)</td></tr>
<tr class="memdesc:ga4de36061187ffca3834ee403bfaff57d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the item at the supplied <em>index</em> or a null pointer if it is out of bounds.  <a href="group__cinterface.html#ga4de36061187ffca3834ee403bfaff57d">More...</a><br /></td></tr>
<tr class="separator:ga4de36061187ffca3834ee403bfaff57d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga5004f8c9e45e57e43b09d6160648591c"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga5004f8c9e45e57e43b09d6160648591c">XsArray_atIndex</a> (void *, XsSize index)</td></tr>
<tr class="memdesc:ga5004f8c9e45e57e43b09d6160648591c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the item at the supplied <em>index</em> or a null pointer if it is out of bounds.  <a href="group__cinterface.html#ga5004f8c9e45e57e43b09d6160648591c">More...</a><br /></td></tr>
<tr class="separator:ga5004f8c9e45e57e43b09d6160648591c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac8d1845c9e3d0e754c40807de07208d4"><td class="memItemLeft" align="right" valign="top">
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#gac8d1845c9e3d0e754c40807de07208d4">XsArray_removeDuplicates</a> (void *)</td></tr>
<tr class="memdesc:gac8d1845c9e3d0e754c40807de07208d4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes duplicate entries from the array, keeping only the first instance of each value. <br /></td></tr>
<tr class="separator:gac8d1845c9e3d0e754c40807de07208d4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad6fd24b950238efd3b37a8baa8035bdb"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#gad6fd24b950238efd3b37a8baa8035bdb">XsArray_removeDuplicatesPredicate</a> (void *, XsArrayItemCompareFunc predicate)</td></tr>
<tr class="memdesc:gad6fd24b950238efd3b37a8baa8035bdb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes duplicate entries from the array, keeping only the first instance of each value.  <a href="group__cinterface.html#gad6fd24b950238efd3b37a8baa8035bdb">More...</a><br /></td></tr>
<tr class="separator:gad6fd24b950238efd3b37a8baa8035bdb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf58b413c81de5fca223fec5400d93497"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#gaf58b413c81de5fca223fec5400d93497">XsArray_empty</a> (void const *)</td></tr>
<tr class="memdesc:gaf58b413c81de5fca223fec5400d93497"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether the array is empty.  <a href="group__cinterface.html#gaf58b413c81de5fca223fec5400d93497">More...</a><br /></td></tr>
<tr class="separator:gaf58b413c81de5fca223fec5400d93497"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaa10ad30f3431b893da57aee83b1c36ab"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#gaa10ad30f3431b893da57aee83b1c36ab">XsArray_rawCopy</a> (void *to, void const *from, XsSize count, XsSize iSize)</td></tr>
<tr class="memdesc:gaa10ad30f3431b893da57aee83b1c36ab"><td class="mdescLeft">&#160;</td><td class="mdescRight">Copies items optimized in a direct way.  <a href="group__cinterface.html#gaa10ad30f3431b893da57aee83b1c36ab">More...</a><br /></td></tr>
<tr class="separator:gaa10ad30f3431b893da57aee83b1c36ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4f5d82677d289cd44b222435cadce9df"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#ga4f5d82677d289cd44b222435cadce9df">XsArray_sort</a> (void *)</td></tr>
<tr class="memdesc:ga4f5d82677d289cd44b222435cadce9df"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sorts the array using the <em>itemCompare</em> func in the <a class="el" href="struct_xs_array_descriptor.html" title="This object describes how to treat the data in an array. ">XsArrayDescriptor</a>.  <a href="group__cinterface.html#ga4f5d82677d289cd44b222435cadce9df">More...</a><br /></td></tr>
<tr class="separator:ga4f5d82677d289cd44b222435cadce9df"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad632e91875917de99f559bbcbbdb3774"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__cinterface.html#gad632e91875917de99f559bbcbbdb3774">XsArray_reverse</a> (void *)</td></tr>
<tr class="memdesc:gad632e91875917de99f559bbcbbdb3774"><td class="mdescLeft">&#160;</td><td class="mdescRight">Reverses the contents of the array by repeatedly using the <em>itemSwap</em> func in the <a class="el" href="struct_xs_array_descriptor.html" title="This object describes how to treat the data in an array. ">XsArrayDescriptor</a>.  <a href="group__cinterface.html#gad632e91875917de99f559bbcbbdb3774">More...</a><br /></td></tr>
<tr class="separator:gad632e91875917de99f559bbcbbdb3774"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Provides generic storage for data in an array and manipulation operations on that data. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="aef16b8d4034c873176dec9742a83e6ac"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">XsArray::XsArray </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct_xs_array_descriptor.html">XsArrayDescriptor</a> const *&#160;</td>
          <td class="paramname"><em>descriptor</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">XsSize&#160;</td>
          <td class="paramname"><em>count</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void const *&#160;</td>
          <td class="paramname"><em>src</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Initializes the <a class="el" href="struct_xs_array.html" title="Provides generic storage for data in an array and manipulation operations on that data...">XsArray</a> with space for <em>count</em> items and copies them from <em>src</em>. </p>
<p>This function initializes the object reserving <em>count</em> items in the buffer. <em>count</em> may be 0. If <em>src</em> is not 0, <em>count</em> items from <em>src</em> will be copied. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">descriptor</td><td>The descriptor of the data in the list </td></tr>
    <tr><td class="paramname">count</td><td>The number of items to reserve space for. When <em>src</em> is not NULL, thisArray is also the number of items copied from <em>src</em> </td></tr>
    <tr><td class="paramname">src</td><td>A pointer to an array of objects to copy, may be NULL, ignored when <em>count</em> is 0 </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a40a6e7331ef221bc2abeceb9b72e8e6b"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">XsArray::XsArray </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="struct_xs_array.html">XsArray</a> &amp;&#160;</td>
          <td class="paramname"><em>src</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Initializes the <a class="el" href="struct_xs_array.html" title="Provides generic storage for data in an array and manipulation operations on that data...">XsArray</a> with a copy of <em>src</em>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>A pointer to the objects to copy. The object may be empty, but src may not be 0 </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a0d5f403a6fd0facdd372528d3bc2ea78"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="struct_xs_array.html">XsArray</a> const&amp; XsArray::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="struct_xs_array.html">XsArray</a> &amp;&#160;</td>
          <td class="paramname"><em>src</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Assignment operator. </p>
<p>Copies the values in <em>src</em> into <em>this</em> </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>The array to copy from </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A reference to this </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="ae9b9cac2f5f744895311f343e07ee6c1"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* const XsArray::m_data</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Pointer to contained data buffer </p>

</div>
</div>
<a class="anchor" id="abd1797e031ec46502cc2f43f2a07100d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="struct_xs_array_descriptor.html">XsArrayDescriptor</a> const* const XsArray::m_descriptor</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Describes how to handle the items in the array </p>

</div>
</div>
<a class="anchor" id="a9f4574fd74cedfc943e8e2bfa534e67f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const int XsArray::m_flags</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Flags for data management </p>

</div>
</div>
<a class="anchor" id="a9a81e31122b1cf37ced75d230407bd3a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const XsSize XsArray::m_reserved</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Size of allocated data buffer in number of items </p>

</div>
</div>
<a class="anchor" id="a0793355de1a10a119d47ab5df4c51228"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const XsSize XsArray::m_size</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Size of used data buffer in number of items </p>

</div>
</div>
</div><!-- contents -->

<div class="tabs">&nbsp;</div>
<hr size="1" />
<address style="text-align: right;">
<small>Generated on Wed May 17 2017 for Xsens by <a href="http://www.doxygen.org/index.html">Doxygen</a> 1.8.11</small>
</address>
</body>
</html>
